import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import javax.tv.xlet.Xlet;
import javax.tv.xlet.XletContext;
import javax.tv.xlet.XletStateChangeException;

import org.havi.ui.HDefaultTextLayoutManager;
import org.havi.ui.HScene;
import org.havi.ui.HSceneFactory;
import org.havi.ui.HScreen;
import org.havi.ui.HStaticText;

/**
* A simple Xlet with a HStaticText label that changes background color
* when a key is pressed.
*/
public class SimpleXlet implements Xlet, KeyListener {

	private XletContext context;
	private HScene scene;
	private HStaticText[] labels;
	private Color[] colors = { Color.black, Color.red, Color.blue };
	private int intColor;
	private int listpos;

	public SimpleXlet() {
	}

	public void initXlet(XletContext xletContext) throws XletStateChangeException {
		System.out.println("begin initXlet");
		context = xletContext;
	}

	public void startXlet() throws XletStateChangeException {
		System.out.println("begin startXlet");
		HSceneFactory hsceneFactory = HSceneFactory.getInstance();
		scene = hsceneFactory.getFullScreenScene(HScreen.getDefaultHScreen().getDefaultHGraphicsDevice());
		labels = new HStaticText[2];
		listpos = 0;

		scene.setSize(160, 200);
		scene.setLayout(null);
		scene.addKeyListener(this);
        
		labels[0] = new HStaticText("IFN MHP Mobil", 10, 20, 160, 80, new Font("Tiresias", Font.BOLD, 20),
			Color.yellow, Color.gray, new HDefaultTextLayoutManager());
		scene.add(labels[0]);
		labels[1] = new HStaticText("[Close]", 100, 150, 30, 15, new Font("Tiresias", Font.BOLD, 14),
			Color.yellow, Color.black, new HDefaultTextLayoutManager());
		scene.add(labels[1]);

		scene.setVisible(true);
		scene.requestFocus();
	}

	public void pauseXlet() {
	}

	public void destroyXlet(boolean flag) throws XletStateChangeException {
		System.out.println("destroyXlet");
		if (scene != null) {
			scene.setVisible(false);
			scene.removeAll();
			scene = null;
		}
		context.notifyDestroyed();
	}
	public void keyTyped(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

    public void keyPressed(KeyEvent e) {
		int keycode = e.getKeyCode();
		if(keycode==java.awt.event.KeyEvent.VK_UP ||
			keycode==java.awt.event.KeyEvent.VK_DOWN){
			listpos = (listpos+1)%2;
			HStaticText label = (HStaticText) labels[listpos];
			HStaticText labelold = (HStaticText) labels[(listpos+1)%2];
			labelold.setBackground(Color.black);
			label.setBackground(Color.gray);
			labelold.repaint();
			label.repaint();
		}
		else if(keycode==java.awt.event.KeyEvent.VK_ENTER && listpos==1){
			try{
				destroyXlet(false);
			}
			catch(XletStateChangeException err){
				err.printStackTrace();
			}
		}
		else if(listpos==0){
//		    try{
//		        PrintStream out = new PrintStream(new FileOutputStream(
//		                new File("test.txt")));
//		        out.print("TADA");
//		        out.close();
//		    }catch(FileNotFoundException exc){exc.printStackTrace();}
			
			intColor++;
			if (intColor == colors.length) {
				intColor = 0;
			}
			labels[listpos].setBackground(colors[intColor]);
			labels[listpos].repaint();
		}

	}

}
